import { Component, Injectable, NgModule } from '@angular/core';
import { HttpHeaders, HttpClient } from '@angular/common/http';

class CgstLibAngularComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
CgstLibAngularComponent.decorators = [
    { type: Component, args: [{
                selector: 'cgst-lib-angular',
                template: `
    <p>
      cgst-lib-angular works!
    </p>
  `
            },] }
];
CgstLibAngularComponent.ctorParameters = () => [];
(function (CgstLibAngularComponent) {
    class HttpReQuestModule {
        constructor(http) {
            this.http = http;
        }
        ngOnInit() {
        }
        // Purpose:
        // To create Http Requests (Post, Get, Put, Delete) to backend server
        // Input parameter:
        // url: URL of the request
        // data: The data to pass in the request body; in JSON format
        // token: The token required for authentication
        // Output:
        // Data in JSON format if succeed; or an error message in string if failed
        post(url, endPoints, data, token) {
            let myHttpHeaders = new HttpHeaders({
                'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + token,
            });
            let myHttpOptions = { headers: myHttpHeaders };
            const URL = url + endPoints;
            return this.http.post(URL, data, myHttpOptions);
            // Interceptor to handle error message
            // .pipe(
            //   catchError(this.handleError),
            //   tap(resData => {
            //       resData['msg'];
            //   })
            // );
        }
        put(url, endPoints, data, token) {
            let myHttpHeaders = new HttpHeaders({
                'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + token,
            });
            let myHttpOptions = { headers: myHttpHeaders };
            const URL = url + endPoints;
            return this.http.put(URL, data, myHttpOptions);
            // Interceptor to handle error message
            // .pipe(
            //   catchError(this.handleError),
            //   tap(resData => {
            //       resData['msg'];
            //   })
            // );
        }
        get(url, endPoints, data, token) {
            let myHttpHeaders = new HttpHeaders({
                'Content-Type': 'raw',
                // 'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + token,
            });
            const URL = url + endPoints;
            // let myParams = JSON.stringify(encodeURI(new URLSearchParams(data2).toString()));
            // let myParams = decodeURI(JSON.stringify(data2))
            // let myParams = Object.keys(data).map(k => `${encodeURIComponent(k)}=${encodeURIComponent(data[k])}`).join('&');
            // let myParams = new HttpParams();
            // myParams = myParams.append("no", "12");
            // myParams = myParams.append("location_region", "C");
            // myParams = myParams.append("location_block", "5");
            // myParams = myParams.append("location_column", "4");
            // myParams = myParams.append("location_row", "5");
            // myParams = myParams.append("size", "S");
            // myParams = myParams.append("status", "A");
            // myParams = myParams.append("remark", "active lu");
            // myParams = myParams.append("created_by", "Eric.INITIAL.DATA");
            // myParams = myParams.append("created_timestamp", "2021-03-30 16:00:34.346864");
            // myParams = myParams.append("last_updated_by", "Eric.INITIAL.DATA");
            // myParams = myParams.append("last_updated_timestamp", "2021-03-30 16:00:34.346864");
            // const myParams: HttpParams = new HttpParams({
            //   fromObject: { 
            //     // 'no': String(studentId),
            //     data,
            //   }
            // });
            return this.http.get(URL, {
                headers: myHttpHeaders,
                params: data
            });
            // Interceptor to handle error message
            // .pipe(
            //   catchError(this.handleError),
            //   tap(resData => {
            //     console.log(resData['msg'])
            //   })
            // );
        }
        delete(url, endPoints, data, token) {
            let myHttpHeaders = new HttpHeaders({
                'Content-Type': 'raw/json',
                // 'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + token,
            });
            const URL = url + endPoints;
            return this.http.delete(URL, {
                headers: myHttpHeaders,
                params: data
            });
            // Interceptor to handle error message
            // .pipe(
            //   catchError(this.handleError),
            //   tap(resData => {
            //     console.log(resData['msg'])
            //   })
            // );
        }
    }
    HttpReQuestModule.decorators = [
        { type: Injectable }
    ];
    HttpReQuestModule.ctorParameters = () => [
        { type: HttpClient }
    ];
    CgstLibAngularComponent.HttpReQuestModule = HttpReQuestModule;
    class ValidationModule {
        validate_email(input) {
            if (/^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/.test(input)) {
                return (true);
            }
            return (false);
        }
    }
    ValidationModule.decorators = [
        { type: Injectable }
    ];
    CgstLibAngularComponent.ValidationModule = ValidationModule;
})(CgstLibAngularComponent || (CgstLibAngularComponent = {}));

class CgstLibAngularModule {
}
CgstLibAngularModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    CgstLibAngularComponent
                ],
                imports: [],
                exports: [
                    CgstLibAngularComponent
                ]
            },] }
];

/*
 * Public API Surface of cgst-lib-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CgstLibAngularComponent, CgstLibAngularModule };
//# sourceMappingURL=cgst-lib-angular.js.map
